| Exiv2

Loading...
Searching...
No Matches
Public Types | List of all members
Exiv2::XmpTextValue Class Reference

Value type suitable for simple XMP properties and XMP nodes of complex types which are not parsed into specific values. More...

`#include <value.hpp>`

Inheritance diagram for Exiv2::XmpTextValue:
[legend]

## Public Types
using | UniquePtr = std::unique_ptr<XmpTextValue>
| Shortcut for a XmpTextValue auto pointer.
Public Types inherited from Exiv2::XmpValue
enum | XmpArrayType { xaNone , xaAlt , xaBag , xaSeq }
| XMP array types.
enum | XmpStruct { xsNone , xsStruct }
| XMP structure indicator.
using | UniquePtr = std::unique_ptr<XmpValue>
| Shortcut for a XmpValue auto pointer.
Public Types inherited from Exiv2::Value
using | UniquePtr = std::unique_ptr<Value>
| Shortcut for a Value auto pointer.

## Public Member Functions
Creators
| XmpTextValue ()
| Constructor.
| XmpTextValue (const std::string &buf)
| Constructor, reads the value from a string.
Manipulators
int | read (const std::string &buf) override
| Read a simple property value from buf to set the value.
int | read (const byte *buf, size_t len, ByteOrder byteOrder=invalidByteOrder) override
Public Member Functions inherited from Exiv2::XmpValue
XmpArrayType | xmpArrayType () const
| Return XMP array type, indicates if an XMP value is an array.
XmpStruct | xmpStruct () const
| Return XMP struct, indicates if an XMP value is a structure.
size_t | size () const override
| Return the size of the value in bytes.
size_t | copy (byte *buf, ByteOrder byteOrder=invalidByteOrder) const override
| Write value to a character data buffer.
void | setXmpArrayType (XmpArrayType xmpArrayType)
| Set the XMP array type to indicate that an XMP value is an array.
void | setXmpStruct (XmpStruct xmpStruct=xsStruct)
| Set the XMP struct type to indicate that an XMP value is a structure.
int | read (const byte *buf, size_t len, ByteOrder byteOrder=invalidByteOrder) override
Public Member Functions inherited from Exiv2::Value
| Value (TypeId typeId)
| Constructor, taking a type id to initialize the base class with.
virtual | ~Value ()=default
| Virtual destructor.
virtual int | setDataArea (const byte *buf, size_t len)
| Set the data area, if the value has one by copying (cloning) the buffer pointed to by buf.
TypeId | typeId () const
| Return the type identifier (Exif data format type).
UniquePtr | clone () const
| Return an auto-pointer to a copy of itself (deep copy). The caller owns this copy and the auto-pointer ensures that it will be deleted.
std::string | toString () const
| Return the value as a string. Implemented in terms of write(std::ostream& os) const of the concrete class.
virtual std::string | toString (size_t n) const
| Return the n-th component of the value as a string. The default implementation returns toString(). The behaviour of this method may be undefined if there is no n-th component.
virtual size_t | sizeDataArea () const
| Return the size of the data area, 0 if there is none.
virtual DataBuf | dataArea () const
| Return a copy of the data area if the value has one. The caller owns this copy and DataBuf ensures that it will be deleted.
bool | ok () const
| Check the ok status indicator. After a to<Type> conversion, this indicator shows whether the conversion was successful.

## Accessors
std::string | value_
| Stores the string values.
UniquePtr | clone () const
size_t | size () const override
| Return the size of the value in bytes.
size_t | count () const override
| Return the number of components of the value.
int64_t | toInt64 (size_t n=0) const override
| Convert the value to an int64_t. The optional parameter n is not used and is ignored.
uint32_t | toUint32 (size_t n=0) const override
| Convert the value to an uint32_t. The optional parameter n is not used and is ignored.
float | toFloat (size_t n=0) const override
| Convert the value to a float. The optional parameter n is not used and is ignored.
Rational | toRational (size_t n=0) const override
| Convert the value to a Rational. The optional parameter n is not used and is ignored.
std::ostream & | write (std::ostream &os) const override
| Write the value to an output stream. You do not usually have to use this function; it is used for the implementation of the output operator for Value, operator<<(std::ostream &os, const Value &value).

## Additional Inherited Members
static XmpArrayType | xmpArrayType (TypeId typeId)
| Return XMP array type for an array Value TypeId, xaNone if typeId is not an XMP array value type.
static UniquePtr | create (TypeId typeId)
| A (simple) factory to create a Value type.
| Value (const Value &)=default
Value & | operator= (const Value &)=default
| Assignment operator. Protected so that it can only be used by subclasses but not directly.
bool | ok_ {true}
| Indicates the status of the previous to<Type> conversion.

## Detailed Description

Value type suitable for simple XMP properties and XMP nodes of complex types which are not parsed into specific values.

Uses a std::string to store the value.

Examples
  xmpsample.cpp.

## Member Function Documentation

## ◆ count()

size_t Exiv2::XmpTextValue::count | ( |  | ) | const
| override virtual

Return the number of components of the value.

Implements Exiv2::Value.

References size().

## ◆ read() [1/2]

int Exiv2::XmpValue::read | ( | const byte * | buf,
|  | size_t | len,
|  | ByteOrder | byteOrder = invalidByteOrder )
| override virtual

Note
  Uses read(const std::string& buf)

Implements Exiv2::Value.

References Exiv2::Value::ok_, and value_.

## ◆ read() [2/2]

int Exiv2::XmpTextValue::read | ( | const std::string & | buf | ) |
| override virtual

Read a simple property value from buf to set the value.

Sets the value to the contents of buf. A optional keyword, type is supported to set the XMP value type. This is useful for complex value types for which Exiv2 does not have direct support.

The format of buf is:
`[type=["]Alt|Bag|Seq|Struct["] ]text`

Returns
  0 if successful.

Implements Exiv2::XmpValue.

References Exiv2::XmpValue::setXmpArrayType(), Exiv2::XmpValue::setXmpStruct(), and value_.

Referenced by XmpTextValue().

## ◆ size()

size_t Exiv2::XmpTextValue::size | ( |  | ) | const
| override virtual

Return the size of the value in bytes.

Implements Exiv2::Value.

References write().

Referenced by count().

## ◆ toFloat()

float Exiv2::XmpTextValue::toFloat | ( | size_t | n = 0 | ) | const
| override virtual

Convert the value to a float. The optional parameter n is not used and is ignored.

Returns
  The converted value.

Implements Exiv2::Value.

References Exiv2::Value::ok_, Exiv2::parseFloat(), and value_.

## ◆ toInt64()

int64_t Exiv2::XmpTextValue::toInt64 | ( | size_t | n = 0 | ) | const
| override virtual

Convert the value to an int64_t. The optional parameter n is not used and is ignored.

Returns
  The converted value.

Implements Exiv2::Value.

References Exiv2::Value::ok_, Exiv2::parseInt64(), and value_.

## ◆ toRational()

Rational Exiv2::XmpTextValue::toRational | ( | size_t | n = 0 | ) | const
| override virtual

Convert the value to a Rational. The optional parameter n is not used and is ignored.

Returns
  The converted value.

Implements Exiv2::Value.

References Exiv2::Value::ok_, Exiv2::parseRational(), and value_.

## ◆ toUint32()

uint32_t Exiv2::XmpTextValue::toUint32 | ( | size_t | n = 0 | ) | const
| override virtual

Convert the value to an uint32_t. The optional parameter n is not used and is ignored.

Returns
  The converted value.

Implements Exiv2::Value.

References Exiv2::Value::ok_, Exiv2::parseUint32(), and value_.

## ◆ write()

std::ostream & Exiv2::XmpTextValue::write | ( | std::ostream & | os | ) | const
| override virtual

Write the value to an output stream. You do not usually have to use this function; it is used for the implementation of the output operator for Value, operator<<(std::ostream &os, const Value &value).

Implements Exiv2::Value.

References value_, Exiv2::XmpValue::xmpArrayType(), and Exiv2::XmpValue::xmpStruct().

Referenced by size().

The documentation for this class was generated from the following files:

- value.hpp
- value.cpp